<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:param name="ID" value="XCA1"/>
    <ui:define name="body">
        <h:form id="globalForm">
            <rich:messages globalOnly="true" styleClass="message"/>

            #{xcaQueryManager.init()}
            <s:div id="globalDiv">
                <h1>#{xcaQueryManager.getTheNameOfThePage()}</h1>
                <gri:panel id="mainPanel">
                    <f:facet name="header">#{xcaQueryManager.getTheNameOfThePage()}</f:facet>
                    <s:div
                            rendered="#{xcaQueryManager.selectedAffinityDomain!= null and xcaQueryManager.selectedTransaction!= null}">
                        <h:outputText
                                value="#{messages['net.ihe.gazelle.xdstar.ThisToolProvidesThePossibilityToCreateAValidRequ']} "/>
                        <h:outputText
                                value="#{xcaQueryManager.selectedTransaction.keyword}"/>
                        <br/>
                        <h:outputText
                                value="#{messages['net.ihe.gazelle.xdstar.ToUseThisToolYouHaveTo']} "/>
                        <br/>
                        <ul>
                            <li>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.xdstar.SelectYourResponderConfigurationOrAddANewOneOnTh']} "/>
                                <h:outputLink
                                        value="/XDStarClient/configuration/common/configurations.seam"
                                        title="#{messages['net.ihe.gazelle.xdstar.XDSRespondersConfigurations']}">
                                    #{messages['net.ihe.gazelle.xdstar.Configurations']}
                                </h:outputLink>
                                <h:outputText value=". "/>
                            </li>
                            <li>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.xdstar.SelectTheMessageTypeYouWantToExecute']}"/>
                            </li>
                            <li>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.xdstar.YouCanAddOptionalMethadatasByClickingOnTheButton']}"/>
                            </li>
                            <li>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.xdstar.FulfilMetadatasOfTheRequest']} "/>
                            </li>
                            <li>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.xdstar.ClickOnTheButtonexecuteToExecuteTheRequest']}"/>
                            </li>
                        </ul>
                    </s:div>
                    <s:div id="configurationDiv">
                        <ui:include src="/simu/header.xhtml">
                            <ui:param name="divToRerender"
                                      value="messageConfigurationDiv,messagesDiv,actionButtons"/>
                            <ui:param name="simuManager" value="#{xcaQueryManager}"/>
                            <ui:param name="diagramFile"
                                      value="/img/XCA.png"/>
                            <ui:param name="sourceID"
                                      value="#{xcaQueryManager.getSourceOid()}"/>
                            <ui:param name="homeCommunityID"
                                      value="#{xcaQueryManager.gethomeCommunityId()}"/>
                            <ui:param name="simulatorConfigurationName"
                                      value="#{messages['net.ihe.gazelle.xdstar.INITGatewaySimulator']}"/>
                            <ui:param name="displaySourceId" value="#{false}"/>
                            <ui:param name="displayhomeCommunityId" value="#{true}"/>
                        </ui:include>
                        <s:div id="messageConfigurationDiv">
                            <!-- MESSAGE TYPE -->
                            <div class="row">
                                <div class="col-md-3">
                                    <s:decorate id="mtDecorate" template="/layout/form/_edit.xhtml"
                                                rendered="#{(xcaQueryManager.selectedTransaction != null) and (xcaQueryManager.selectedConfiguration != null)}">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.MessageType']}
                                        </ui:define>
                                        <h:selectOneMenu value="#{xcaQueryManager.selectedMessageType}"
                                                         styleClass="form-control gzl-form-control gzl-select-text">
                                            <s:selectItems
                                                    value="#{xcaQueryManager.getListOfMessageTypesForSelectedTransaction()}"
                                                    var="mt" label="#{mt.displayAttributeName}"
                                                    noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.PleaseSelect']}"/>
                                            <a4j:ajax event="change"
                                                      render="messageConfigurationDiv,actionButtons"
                                                      listener="#{xcaQueryManager.initAdhocQueryByMessageType()}"/>
                                            <s:convertEntity/>
                                        </h:selectOneMenu>
                                    </s:decorate>
                                </div>
                            </div>
                            <s:div id="messageConfigurationDivR"
                                   rendered="#{xcaQueryManager.selectedMessageType != null}">
                                <f:subview id="subview_1">
                                    <ui:include src="/rsqcommon/parameters.xhtml">
                                        <ui:param name="CommonAQManagerBean"
                                                  value="#{xcaQueryManager}"/>
                                    </ui:include>
                                </f:subview>
                                <!-- RETURN TYPE -->
                                <div class="row">
                                    <div class="col-md-3">
                                        <s:decorate id="rtDecorate" template="/layout/form/_edit.xhtml"
                                                    rendered="#{xcaQueryManager.selectedMessageType != null}">
                                            <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.ReturnType']}
                                            </ui:define>
                                            <h:selectOneMenu value="#{xcaQueryManager.selectedReturnType}"
                                                             styleClass="form-control gzl-form-control gzl-select-text">
                                                <f:selectItems
                                                        value="#{xcaQueryManager.getListOfReturnTypes()}" var="rt"
                                                        label="#{rt}"
                                                        noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.PleaseSelect_2']}"/>
                                            </h:selectOneMenu>
                                        </s:decorate>
                                    </div>
                                </div>
                                <!-- XUA -->
                                <f:subview id="subview_2">
                                    <ui:include src="/simu/xua.xhtml">
                                        <ui:param name="simuManager" value="#{xcaQueryManager}"/>
                                    </ui:include>
                                </f:subview>
                            </s:div>
                        </s:div>
                    </s:div>
                    <!-- send button -->
                    <s:div id="actionButtons">
                        <a4j:commandButton id="previewButton" styleClass="gzl-btn-blue"
                                           oncomplete="jq162('#previewMessagePanel').modal('show');"
                                           value="#{messages['net.ihe.gazelle.xdstar.Preview']}"
                                           rendered="#{xcaQueryManager.selectedMessageType != null}"
                                           render="previewForm,previewMessagePanel"/>
                        <a4j:commandButton id="sendButton" styleClass="gzl-btn-green"
                                           actionListener="#{xcaQueryManager.sendMessage()}"
                                           value="#{messages['gazelle.xca.initgw.Execute']}"
                                           rendered="#{xcaQueryManager.selectedMessageType != null}"
                                           render="messagesDiv"/>
                        <!-- reset button -->
                        <a4j:commandButton id="resetButton" styleClass="gzl-btn"
                                           actionListener="#{xcaQueryManager.reset()}"
                                           value="#{messages['gazelle.xca.initgw.Reset']}"
                                           render="globalDiv"/>
                    </s:div>
                </gri:panel>
                <!--  response div -->
                <s:div id="messagesDiv">
                    <gri:panel id="messagesPanel"
                               rendered="#{xcaQueryManager.displayResultPanel == true}">
                        <f:facet name="header">#{messages['gazelle.xca.initgw.ExecutionSummary']}</f:facet>
                        #{allMessageManagerBean.listMessagesToDisplay()}
                        <f:subview id="subview_3">
                            <ui:include id="messageTable" src="/messages/messageTable.xhtml">
                                <ui:param name="messageManagerBean"
                                          value="#{allMessageManagerBean}"/>
                            </ui:include>

                        </f:subview>
                        <br/>

                        <s:div>
                            #{allMessageManagerBean.initFirstMessage()}
                            <ui:include src="/rsqcommon/respViewer.xhtml">
                                <ui:param name="resp"
                                          value="#{allMessageManagerBean.selectedAdhocQueryResponseType}"/>
                            </ui:include>
                            <br/>
                        </s:div>
                    </gri:panel>
                </s:div>
            </s:div>
        </h:form>
        <h:form id="previewForm">
            <gri:popupPanel id="previewMessagePanel" styleClass="modal-lg">
                <f:facet name="header">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xdstar.MessagePreview']}"/>
                </f:facet>
                <f:facet name="footer">
                    <div align="right">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                           onclick="jq162('#previewMessagePanel').modal('hide')"
                                           execute="@this"/>
                    </div>
                </f:facet>
                <s:div id="previewMessagePanelDiv"
                       rendered="#{xcaQueryManager.selectedMessageType != null}"
                       style="overflow: auto; width: 880px; height: 470px;">
                    <gdk:insert id="highlightcontent"
                                content="#{xcaQueryManager.previewMessage()}" highlight="xml"/>
                </s:div>
            </gri:popupPanel>
        </h:form>
        <f:subview id="subview_5">
            <ui:include src="/rsqcommon/aqmodalPanels.xhtml">
                <ui:param name="CommonAQManagerBean" value="#{xcaQueryManager}"/>
            </ui:include>
        </f:subview>
    </ui:define>
</ui:composition>
